 ###############################################
#                                               #
#              H Y P E R C A L C                #
#     v1.0 (07/04/2010)    2010 MenzAgitat     #
#                                               #
#        IRC:  irc.epiknet.org  #boulets        #
#          http://www.boulets-roxx.com          #
#                                               #
#     Mes scripts sont tlchargeables sur      #
#            http://www.eggdrop.fr              #
#        ou  http://www.egghelp.org             #
#                                               #
 ###############################################

#
# Description : Calculette.
# Syntaxe : !calcule <expression>
# Caractres supports : 0-9 + - * / ( ) % ^ , .
# Fonctions supportes : round wide sqrt sin log10 double hypot atan bool rand abs acos atan2 entier srand sinh log floor tanh tan isqrt int asin min ceil cos cosh exp max fmod pi inf
#
# Pour une fois que je peux crire une description claire et concise, c'est
# comme des vacances...
#
# FAQ :
# Q: Pourquoi "HYPERcalc" alors que c'est une calculette toute bte ?
# R: Pourquoi pas, a sonne bien :]
#



#
# Changelog
#
# 1.0 - 1re version
#

#
# LICENCE:
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#

if {[info commands hypercalc::uninstall] eq "::hypercalc::uninstall"} { hypercalc::uninstall }
# Note pour les programmeurs :
# Dans la version 1.6.19 d'eggdrop, le numro de version affich par .vbottree
# et [numversion] est incorrect; il affiche 1061800 ou 1061801, ce qui
# correspond  la version 1.6.18. On utilise donc une autre technique pour
# vrifier le numro de version.
if { [join [split [string range [lindex $version 0] 0 5] "."] ""] < 1619 } { putloglev o * "\00304\002\[HyperCalc - ERREUR\]\002\003 La version de votre eggdrop est \00304\002$version\002\003; \002HyperCalc\002 ne fonctionnera correctement que sur les eggdrops version 1.6.19 ou suprieure." ; return }
if { [info tclversion] < 8.5 } { putloglev o * "\00304\002\[HyperCalc - ERREUR\]\002\003 \002HyperCalc\002 ncessite que Tcl 8.5 (ou plus) soit install pour fonctionner. Votre version actuelle de Tcl est \00304\002$tcl_version\002\003." ; return }
package require Tcl 8.5
namespace eval hypercalc {


	##############################
	#				CONFIGURATION        #
	##############################

	##### Commande(s) publique(s) spares par un espace
	variable hypercalc_cmd "!calcule !calc"

	##### Utiliser une mise en forme (couleur, gras, ...) pour afficher les
	##### rsultats ?  ( 1 = oui, 0 = non )
	variable use_colors 1

	##### Activer la protection contre le flood ?  ( 1 = oui, 0 = non )
	variable antiflood 1

	# Tolrance de l'anti-flood (nombre de requtes:nombre de secondes)
	variable antiflood_max_request 5:30

	# Intervalle de temps minimum en secondes entre l'affichage de 2 messages
	# avertissant que l'anti-flood a t dclench (ne rglez pas cette valeur
	# trop bas afin de ne pas tre flood par les messages d'avertissement de
	# l'anti-flood...)
	variable antiflood_msg_interval 30




####################################################################
#                                                                  #
# NE MODIFIEZ RIEN APRES CE CADRE SI VOUS NE CONNAISSEZ PAS LE TCL #
#                                                                  #
#   DO NOT MODIFY ANYTHING BELOW THIS BOX IF YOU DON'T KNOW TCL    #
#                                                                  #
####################################################################

	###
	### Initialisation
	###
  variable scriptname "HyperCalc"
  variable version "1.0.20100407"
	variable antiflood_max_request [split $antiflood_max_request ":"]
	# Initialisation du flag hypercalc et activation par dfaut sur tous les chans
	# s'il s'agit du 1er lancement du script.
	if { [lsearch -regexp [channel info [lindex [set chans [channels]] 0]] {^(\+|\-)hypercalc$}] == -1 } {
		setudef flag hypercalc
		foreach channame $chans { channel set $channame +hypercalc }
	} else {
		setudef flag hypercalc
	}
	# Procdure de dsinstallation
	# (le script se dsinstalle totalement avant chaque rehash ou  chaque relecture au moyen de la commande "source" ou autre)
	proc uninstall {args} {
		putlog "Dsallocation des ressources de \002$hypercalc::scriptname\002..."
		foreach binding [lsearch -inline -all -regexp [binds *[set ns [string range [namespace current] 2 end]]*] " \{?(::)?$ns"] {
			unbind [lindex $binding 0] [lindex $binding 1] [lindex $binding 2] [lindex $binding 4]
		}
		foreach running_timer [timers] {
			if { [string match "*[namespace current]::*" [lindex $running_timer 1]] } { killtimer [lindex $running_timer 2] }
		}
		foreach running_utimer [utimers] {
			if { [string match "*[namespace current]::*" [lindex $running_utimer 1]] } { killutimer [lindex $running_utimer 2] }
		}
		namespace delete ::hypercalc
	}
}

###
### Cration d'une nouvelle fonction pour expr, retournant Pi
###
if {[info commands ::tcl::mathfunc::pi] eq ""} {
	proc ::tcl::mathfunc::pi {} {
		return [expr 4*atan(1)]
	}
}

###
### calcul
###
proc hypercalc::calc {nick host hand chan arg} {
	if { (($hypercalc::antiflood == 1) && ([hypercalc::antiflood $chan] == "flood")) } {
		return
	} elseif { ($arg eq "") || ([regsub -all { } $arg ""] eq "") } {
		puthelp "PRIVMSG $chan :[code underline]Syntaxe[code underline] : [lindex $hypercalc::hypercalc_cmd 0] [code 14]<[code endcolor]expression[code 14]> [code 07]|[code 14] Caractres supports : 0-9 + - * / ( ) % ^ , . [code 07]|[code 14] Fonctions supportes : round wide sqrt sin log10 double hypot atan bool rand abs acos atan2 entier srand sinh log floor tanh tan isqrt int asin min ceil cos cosh exp max fmod pi inf[code endcolor]"
		return
	} elseif { [regsub -all {([0-9\+\-\*/\(\)%\^\ ,\.]|sin|round|wide|sqrt|sin|log10|double|hypot|atan|bool|rand|abs|acos|atan2|entier|srand|sinh|log|floor|tanh|tan|isqrt|int|asin|min|ceil|cos|cosh|exp|max|fmod|pi|inf)} [set arg [::tcl::string::tolower $arg]] ""] ne "" } {
		puthelp "PRIVMSG $chan :[code 04][code bold]\[HyperCalc - ERREUR\][code bold][code 14] Votre expression contient des caractres ou des fonctions invalides. [code 07]|[code 14] Caractres supports : 0-9 + - * / ( ) % ^ , . [code 07]|[code 14] Fonctions supportes : round wide sqrt sin log10 double hypot atan bool rand abs acos atan2 entier srand sinh log floor tanh tan isqrt int asin min ceil cos cosh exp max fmod pi inf[code endcolor]"
		return
	}
	foreach element [regsub -all {[+\-/*\(\)%\^,\.]} $arg { & }] {
		if { (![::tcl::string::is digit $element]) && ([lsearch {+ - * / ( ) % ^ , . sin round wide sqrt sin log10 double hypot atan bool rand abs acos atan2 entier srand sinh log floor tanh tan isqrt int asin min ceil cos cosh exp max fmod pi inf} $element] == -1) } {
			puthelp "PRIVMSG $chan :[code 04][code bold]:::[code bold][code 14] fonction \"$element\" inconnue. [code 07]|[code 14] Liste des fonctions supportes : round wide sqrt sin log10 double hypot atan bool rand abs acos atan2 entier srand sinh log floor tanh tan isqrt int asin min ceil cos cosh exp max fmod pi inf[code endcolor]"
			return
		}
	}
	# on interdit l'usage direct de ** et on substitue **  ^
	set arg [string map {** "* *" ^ **} $arg]
	# on supprime les 0 au dbut des valeurs afin que l'interprteur ne les confonde pas avec des valeurs octales/hexadcimales/binaires
	set arg [regsub -all {\s+} [regsub -all {\s0+([1-9]+)} [regsub -all {([+\-/\(\)%\^,]|(\*\*)|(\*))} " $arg" { & }] { \1}] " "]
	# pr-valuation de l'expression afin de s'assurer qu'on ne va pas demander 
	# Tcl d'effectuer des calculs de puissances trop grandes, ce qui aurait pour
	# rsultat de lancer crasher votre eggdrop. Il s'agit d'un bricolage immonde
	# mais la meilleure alternative qu'on m'ait propos pour viter a a t de
	# changer de langage de programmation... hein Merwin :
	catch { eval secure_expr $chan \"[regsub -all {\)} [regsub -all {(sin\(|round\(|wide\(|sqrt\(|sin\(|log10\(|double\(|hypot\(|atan\(|bool\(|rand\(|abs\(|acos\(|atan2\(|entier\(|srand\(|sinh\(|log\(|floor\(|tanh\(|tan\(|isqrt\(|int\(|asin\(|min\(|ceil\(|cos\(|cosh\(|exp\(|max\(|fmod\(|pi\(|inf\(|\()} [string map {"* *" "* *" " " ""} $arg] "\[secure_expr \$chan \""] "\"\]"]\"} dummy
	if { $dummy eq "error" } { return }
	# on force les valeurs  tre dcimales lorsqu'elles sont accoles aux oprateurs / ou **
	set arg2 [regsub {\*\*([0-9\-\.]+)} [string map {/ *1.0/} ${arg}] {**(1.0*\1)}]
	# interception et traduction des erreurs
	if { [catch {set result [expr $arg2]} error] } {
		# on rvalue sans la bidouille pour convertir l'oprande d'une division en virgule flottante, car sinon c'est visible dans l'erreur
		catch { expr $arg } error
		set error [join [split $error]]
		switch -glob -- $error {
			{divide by zero} {
				puthelp "PRIVMSG $chan :[code 04][code bold]:::[code bold][code 14] division par zro[code endcolor]"
			}
			{unbalanced open paren in expression *} {
				puthelp "PRIVMSG $chan :[code 04][code bold]:::[code bold][code 14] parenthse ouvrante dsquilibre[code endcolor]"
			}
			{unbalanced close paren in expression *} {
				puthelp "PRIVMSG $chan :[code 04][code bold]:::[code bold][code 14] parenthse fermante dsquilibre[code endcolor]"
			}
			{too few arguments for math function *} {
				puthelp "PRIVMSG $chan :[code 04][code bold]:::[code bold][code 14] la fonction [lindex [split $error] 6] attend plus d'arguments[code endcolor]"
			}
			{too many arguments for math function *} {
				puthelp "PRIVMSG $chan :[code 04][code bold]:::[code bold][code 14] la fonction [lindex [split $error] 6] attend moins d'arguments[code endcolor]"
			}
			{invalid bareword "rand" in expression *} {
				puthelp "PRIVMSG $chan :[code 04][code bold]:::[code bold][code 14] la syntaxe correcte est : rand()[code endcolor]"
			}
			{invalid bareword "pi" in expression *} - {wrong # args: should be "tcl::mathfunc::pi"} {
				puthelp "PRIVMSG $chan :[code 04][code bold]:::[code bold][code 14] la syntaxe correcte est : pi()[code endcolor]"
			}
			{invalid bareword * in expression *} {
				puthelp "PRIVMSG $chan :[code 04][code bold]:::[code bold][code 14] la syntaxe correcte est : [join [lindex [split $error] 2]](...)[code endcolor]"
			}
			{missing operand at _@_ in expression *} {
				puthelp "PRIVMSG $chan :[code 04][code bold]:::[code bold][code 14] oprande manquant  la position _@_ dans l'expression [string map "_@_ \"[code endcolor]_@_[code 14]\002\002\" ** ^" [regsub -all { _@_} [join [lrange [split $error] 6 end] ""] "_@_"]][code endcolor]"
			}
			{missing operator at _@_ in expression *} {
				puthelp "PRIVMSG $chan :[code 04][code bold]:::[code bold][code 14] oprateur manquant  la position _@_ dans l'expression [string map "_@_ \"[code endcolor]_@_[code 14]\002\002\" ** ^" [join [lrange [split $error] 6 end] ""]][code endcolor]"
			}
			{domain error: argument not in valid range} {
				puthelp "PRIVMSG $chan :[code 04][code bold]:::[code bold][code 14] erreur de domaine : la valeur n'est pas dans une fourchette valide pour la fonction utilise (exemple : valeur ngative passe  une fonction n'acceptant que les valeurs positives).[code endcolor]"
			}
			{empty subexpression at _@_ in expression *} {
				puthelp "PRIVMSG $chan :[code 04][code bold]:::[code bold][code 14] sous-expression vide  la position _@_ dans l'expression [string map "_@_ \"[code endcolor]_@_[code 14]\002\002\" ** ^" [join [lrange [split $error] 6 end] ""]][code endcolor]"
			}
			{can't use floating-point value as operand of *} {
				puthelp "PRIVMSG $chan :[code 04][code bold]:::[code bold][code 14] l'oprande de [join [lrange [split $error] 7 end]] doit tre un entier naturel[code endcolor]"
			}
			{exponent too large*} {
				puthelp "PRIVMSG $chan :[code 04][code bold]:::[code bold][code 14] exposant trop grand[code endcolor]"
			}
			{missing function argument at _@_ in expression *} {
				puthelp "PRIVMSG $chan :[code 04][code bold]:::[code bold][code 14] argument de fonction manquant  la position _@_ dans l'expression [string map "_@_ \"[code endcolor]_@_[code 14]\002\002\" ** ^" [join [lrange [split $error] 7 end] ""]]"
			}
			{invalid character "?" in expression *} {
				puthelp "PRIVMSG $chan :[code 04][code bold]:::[code bold][code 14] caractre [join [lindex [split $error] 2]] invalide dans l'expression [regsub -all {\*\*} [join [lrange [split $error] 5 end] ""] "^"][code endcolor]"
			}
			{unexpected "," outside function argument list in expression *} {
				puthelp "PRIVMSG $chan :[code 04][code bold]:::[code bold][code 14] Virgule inattendue en dehors d'une liste d'arguments de fonction dans l'expression [regsub -all {\*\*} [join [lrange [split $error] 8 end] ""] "^"]. La virgule est utilise comme sparateur d'une liste d'arguments passs  une fonction; si vous vouliez utiliser une valeur dcimale, mettez un point.[code endcolor]"
			}
			default {
				puthelp "PRIVMSG $chan :[code 04][code bold]\[HyperCalc - erreur inattendue\][code bold][code 14] $error[code endcolor]"
#				set file_ID [open scripts/hypercalc_errors.txt a]
#				puts $file_ID "$arg\n$error\n-----------------"
#				close $file_ID
				return
			}
		}
		return
	}
	if { [string last ".0" $result end] != -1 } { set result [expr int($result)] }
	puthelp "PRIVMSG $chan :[code 14][regsub -all {\*\*} [regsub -all {\s{1,}} $arg ""] "^"]  =[code endcolor][code bold]  $result[code bold]"
}

###
### valuation de l'expression fragment par fragment afin d'interdire
### l'utilisation de puissances trop grandes (ce qui aurait pour effet de
### crasher l'eggdrop) et pour dtecter proprement les divisions par 0
###
proc hypercalc::secure_expr {chan data} {
putlog "\00312--> $data\003"
	if { [string match "*error*" $data] } {
		return "error"
	# on fixe la valeur plafond  100 pour les exposants
	} elseif { ([string match {*\*\**} $data]) && ([expr max([regsub -all {[^\d]+} $data ","])] > 100) } {
		puthelp "PRIVMSG $chan :[code 04][code bold]:::[code bold][code 14] base ou exposant trop grand[code endcolor]"
		return "error"
	} elseif { [regexp {/0(?!\.)} $data] } {
		puthelp "PRIVMSG $chan :[code 04][code bold]:::[code bold][code 14] division par zro[code endcolor]"
		return "error"
	} else {
		return [expr $data]
	}
}

###
### Gestion couleurs/gras/soulignement
###
proc hypercalc::code {code} {
 	switch -exact -- $code {
		bold {
	    if { $hypercalc::use_colors } { return "\002" } { return "" }
		}
		underline {
    	if { $hypercalc::use_colors } { return "\037" } { return "" }
		}
		endcolor {
	    if { $hypercalc::use_colors } { return "\003" } { return "" }
		}
	  default {
    	if { $hypercalc::use_colors } { return "\003$code" } { return "" }
  	}
	}
}

###
### Contrle du flood
###
proc hypercalc::antiflood {chan} {
  if {![info exists ::hypercalc::antiflood_msg($chan)]} { set ::hypercalc::antiflood_msg($chan) 0 }
  if {![info exists ::hypercalc::instance($chan)]} { set ::hypercalc::instance($chan) 0 }
  set max_instances [lindex $hypercalc::antiflood_max_request 0]
  set instance_length [lindex $hypercalc::antiflood_max_request 1]
  if { $hypercalc::instance($chan) >= $max_instances } {
    if { $hypercalc::antiflood_msg($chan) == 0 } {
      set hypercalc::antiflood_msg($chan) 1
      putquick "privmsg $chan :[code 04][code bold]:::[code bold][code 14] Contrle de flood activ sur la calculatrice : pas plus de $max_instances requte(s) toutes les $instance_length secondes.[code endcolor]"
      utimer $hypercalc::antiflood_msg_interval [list ::hypercalc::antiflood_msg_reset $chan]
    }
    return "flood"
  } else {
    incr ::hypercalc::instance($chan)
    utimer $instance_length [list ::hypercalc::antiflood_close_instance $chan]
    return "no flood"
  }
}
proc hypercalc::antiflood_close_instance {chan} {
  if { ([info exists ::hypercalc::instance($chan)]) && ($::hypercalc::instance($chan) > 0) } { incr ::hypercalc::instance($chan) -1 }
}
proc hypercalc::antiflood_msg_reset {chan} {
  set ::hypercalc::antiflood_msg($chan) 0
}

###
### binds
###
namespace eval hypercalc {
	bind evnt - prerehash hypercalc::uninstall
	foreach cmd $hypercalc::hypercalc_cmd {
		bind pub -|- $cmd hypercalc::calc
	}
}


putlog "\002$hypercalc::scriptname v$hypercalc::version\002 (2010 MenzAgitat) a t charg."
